<?php // $Id: movino_variables.inc,v 1.2 2007/07/13 07:28:27 tomsun Exp $
/*
    Movino Web Frontend - Server handling, feed parsing and feed caching
    Copyright 2006, 2007 Tom Sundström

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public
    License along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
*/


/**
 * Metadata fields available for movino content.
 */
function movino_metadata() {
  return array(
    'player' => t('Embedded player'),
    'icon' => t('Preview icon'),
    'title' => t('Title'),
    'author' => t('Author'),
    'created' => t('Created'),
    'length' => t('Duration'),
    'url' => t('Direct link'),
    'encoding' => t('Encoding'),
  );
}


/**
 * Tell which metadata fields are enabled by default.
 */
function movino_metadata_enabled($teaser = FALSE) {
  if ($teaser) {
    return variable_get('movino_metadata_teaser', array('icon' => 1, 'title' => 1, 'author' => 1, 'created' => 1, 'length' => 1));
  }

  return variable_get('movino_metadata_page', array('player' => 1, 'title' => 1, 'author' => 1, 'created' => 1, 'length' => 1, 'url' => 1));
}


/**
 * Tell if metadata labels should be hidden.
 *
 * @param boolean $teaser
 * @return array
 */
function movino_metadata_labels_enabled($teaser = FALSE) {
  if ($teaser) {
    return variable_get('movino_metadata_labels_enabled_teaser', array());
  }

  return variable_get('movino_metadata_labels_enabled_page', array('title' => 1, 'author' => 1, 'created' => 1, 'length' => 1, 'url' => 1));
}


/**
 * Whether or not to allow the embedded player to be resized.
 */
function movino_player_embed_allow_resize() {
  return variable_get('movino_player_embed_allow_resize', 1);
}


/**
 * Maximum size of embedded video.
 */
function movino_player_embed_scale_max() {
  return 4;
}


/**
 * Minimum size of embedded video.
 */
function movino_player_embed_scale_min() {
  return 1;
}
